<?php
/**
 * +----------------------------------------------------------------------
 * 导入百度地图地区表
 * +----------------------------------------------------------------------
 * 官网：https://blog.junphp.com
 * +----------------------------------------------------------------------
 * 作者：小黄牛 <1731223728@qq.com>
 * +----------------------------------------------------------------------
 * 开源协议：http://www.apache.org/licenses/LICENSE-2.0
 * +----------------------------------------------------------------------
*/

// 数据来源：https://lbsyun.baidu.com/index.php?title=open/dev-res  百度地图行政区划adcode映射表

set_time_limit(120);
ini_set('memory_limit','1024M');

$starttime = explode(' ',microtime());

require_once dirname(__FILE__) .DIRECTORY_SEPARATOR.'vendor'.DIRECTORY_SEPARATOR.'Db'.DIRECTORY_SEPARATOR.'SwooleDb.php';
require_once dirname(__FILE__) .DIRECTORY_SEPARATOR.'vendor'.DIRECTORY_SEPARATOR.'PHPExcel'.DIRECTORY_SEPARATOR.'PHPExcel.php';

$config = require dirname(__FILE__) .DIRECTORY_SEPARATOR. 'database.php';

$dsn      = 'mysql:dbname='.$config['database'].';host='.$config['host'].';port='.$config['port'];
# 连接数据库

try {
    $DB = new PDO($dsn, $config['user'], $config['password']);
    $DB->exec('SET NAMES '.$config['charset'].';');
} catch(PDOException $e) {
    die ('连接失败，错误信息：'.$e->getMessage());
}

$table = $config['prefix'].'region';

// 打开表
$path = dirname(__FILE__) .DIRECTORY_SEPARATOR.'/data.xlsx'; 
$type = 'Excel2007';
$objReader = \PHPExcel_IOFactory::createReader($type);
$obj_PHPExcel =$objReader->load($path, $encode = 'utf-8');  //加载文件内容,编码utf-8
$excel_array=$obj_PHPExcel->getsheet(0)->toArray();   //转换为数组格式
array_shift($excel_array); 

foreach ($excel_array as $v) {
    // 省
    $sql = SwooleDb::run()->table($table)->where('region_name', '=', $v[0])->field('id')->find();
    $res = $DB->query($sql);
    $province = $res->fetch(\PDO::FETCH_NAMED);
    if ($province === false) {
        $add = SwooleDb::run()->table($table)->insert([
            'region_name' => $v[0],
            'pid' => 0,
            'level' => 1,
        ]);
        $DB->exec($add);
        $res = $DB->query($sql);
        $province = $res->fetch(\PDO::FETCH_NAMED);
    }
    // 市
    $sql = SwooleDb::run()->table($table)->where('region_name', '=', $v[2])->where('pid', '=', $province['id'])->field('id')->find();
    $res = $DB->query($sql);
    $city = $res->fetch(\PDO::FETCH_NAMED);
    if ($city === false) {
        $add = SwooleDb::run()->table($table)->insert([
            'region_name' => $v[2],
            'pid' => $province['id'],
            'level' => 2,
        ]);
        $DB->exec($add);
        $res = $DB->query($sql);
        $city = $res->fetch(\PDO::FETCH_NAMED);
    }
    // 区
    $sql = SwooleDb::run()->table($table)->where('region_name', '=', $v[4])->where('pid', '=', $city['id'])->field('id')->find();
    $res = $DB->query($sql);
    $area = $res->fetch(\PDO::FETCH_NAMED);
    if ($area === false) {
        $add = SwooleDb::run()->table($table)->insert([
            'region_name' => $v[4],
            'pid' => $city['id'],
            'level' => 3,
        ]);
        $DB->exec($add);
        $res = $DB->query($sql);
        $area = $res->fetch(\PDO::FETCH_NAMED);
    }
    // 镇
    $sql = SwooleDb::run()->table($table)->where('region_name', '=', $v[6])->where('pid', '=', $area['id'])->field('id')->find();
    $res = $DB->query($sql);
    $town = $res->fetch(\PDO::FETCH_NAMED);
    if ($town === false) {
        $add = SwooleDb::run()->table($table)->insert([
            'region_name' => $v[6],
            'pid' => $area['id'],
            'level' => 4,
        ]);
        $DB->exec($add);
    }
    // exit;
}
$endtime = explode(' ',microtime());
$thistime = $endtime[0]+$endtime[1]-($starttime[0]+$starttime[1]);
$thistime = round($thistime, 5);

die('更新结束，耗时：'.$thistime.' S');