<?php
// +----------------------------------------------------------------------
// 抽象数据库构造器
// +----------------------------------------------------------------------
// Copyright (c) 2020 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

abstract class AbstractDb {
    /**
     * 必须要实现的抽象
    */
    public abstract function table($table); // 选择表
    public abstract function alias($as); // 别名
    public abstract function where($filed, $operator, $value); // 条件
    public abstract function field($field); // 字段
    public abstract function limit($left, $right); // 指定条数
    public abstract function page($left, $right); // 分页数
    public abstract function order($order); // 排序
    public abstract function having($field); // 筛选
    public abstract function group($field); // 分组
    public abstract function join($table, $on, $join); // 连表
    public abstract function select(); // 批量查询
    public abstract function find(); // 查询一条
    public abstract function delete(); // 删除
    public abstract function update($data); // 修改
    public abstract function insert($data); // 新增
    public abstract function setInc($field, $num); // 自增
    public abstract function setDec($field, $num); // 自减
}